#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>



#define BUFLEN 1024

void encrypt(char *key, unsigned int keylen, char *message, unsigned int messagelen, char *output) {
	unsigned int i;
	
	for (i = 0; i < messagelen; i++)
		output[i] = (message[i] + key[i % keylen] - ('A' - 1) - 'A') % ('Z' - 'A') + 'A';
	output[i] = '\0';
}

void decrypt(char *key, unsigned int keylen, char *message, unsigned int messagelen, char *output) {
	unsigned int i;
	
	for (i = 0; i < messagelen; i++)
		output[i] = (message[i] - key[i % keylen]) % ('Z' - 'A') + 'A';
	output[i] = '\0';
}

int main(int argc, char *argv[]) {
	argc = argc;
	argv = argv;
	
	char *message = new char[100010];
	char *output = new char[100010];
	char *key = new char[110];
	char *coolkey = new char[110];
	char *w1 = new char[110];
	char *w2 = new char[110];
	
	char c;
	
	unsigned int i, j;
	unsigned int keylen, messagelen, w1len, w2len;
	unsigned int keys;
	
	bool success;
	
	//~ message = "THISISSECRETMESSAGE";
	message = "CKYVRVIHLUUWHIVJJU";
	//~ message = "B";
	//~ key = "A";
	key = "ICPC";
	decrypt(key, strlen(key), message, strlen(message), output);
	printf("%s\n", output);
	return 1;
	
	while(true)
	{
		fgets(key, 110, stdin);
		sscanf(key, "%u", &keylen);
		memset(key, 0x00, 110);
		
		if (keylen == 0)
			break;
		
		fgets(w1, 110, stdin);
		w1len = strlen(w1) - 1;
		w1[w1len] = '\0';
		
		fgets(w2, 110, stdin);
		w2len = strlen(w2) - 1;
		w2[w2len] = '\0';
		
		fgets(message, 100010, stdin);
		messagelen = strlen(message) - 1;
		message[messagelen] = '\0';
		
		keys = 0;
		for (i = 0; i < messagelen - w1len; i++)
		{
			success = true;
			for (j = 0; j < w1len; j++)
			{
				c = (message[i + j] - w1[j] - 'A') % ('Z' - 'A') + 'A';
				if (key[j % keylen] != '\0' && key[j % keylen] != c)
				{
					success = false;
					break;
				}
				key[j % keylen] = c;
			}
			if (!success)
				continue;
			decrypt(key, keylen, message, messagelen, output);
			if (NULL == strstr(output, w2))
				continue;
			
			memcpy(coolkey, key, 110);
			keys++;
			if (keys > 1)
				break;
		}
		if (keys > 1)
		{
			printf("ambiguous\n");
			continue;
		}
		if (keys == 0)
		{
			printf("impossible\n");
			continue;
		}
		decrypt(coolkey, keylen, message, messagelen, output);
		printf("%s\n", output);
	}
	
	return 0;
}
